-- name: [CS] Demoman
-- description: Made by LukasATBK, Commissioned and voices by Kazenr

local TEXT_MOD_NAME = "Demoman"
local TEXT_MOD_VERSION = "2.0"
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local TEX_DEMOMAN = get_texture_info("demoman_icon")

local VOICETABLE_DEMOMAN = {
    [CHAR_SOUND_ATTACKED] = 'mario_attacked.mp3',
    [CHAR_SOUND_COUGHING1] = 'mario_coughing_1.mp3',
    [CHAR_SOUND_COUGHING2] = 'mario_coughing_1.mp3',
    [CHAR_SOUND_COUGHING3] = 'mario_coughing_1.mp3',
    [CHAR_SOUND_DOH] = 'mario_doh.mp3',
    [CHAR_SOUND_DROWNING] = 'mario_drowning.mp3',
    [CHAR_SOUND_DYING] = 'mario_dying.mp3',
    [CHAR_SOUND_EEUH] = 'mario_pull_up.mp3',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'mario_yah.mp3',
    [CHAR_SOUND_HAHA] = 'mario_haha.mp3',
    [CHAR_SOUND_HAHA_2] = 'mario_haha.mp3',
    [CHAR_SOUND_HERE_WE_GO] = 'mario_here_we_go.mp3',
    [CHAR_SOUND_HOOHOO] = {'mario_hoohoo.mp3', 'mario_hoohoo.mp3'},
    [CHAR_SOUND_HRMM] = 'mario_lift.mp3',
    [CHAR_SOUND_IMA_TIRED] = 'mario_yawning.mp3',
    [CHAR_SOUND_LETS_A_GO] = 'mario_lets_a_go.mp3',
    [CHAR_SOUND_MAMA_MIA] = 'mario_mama_mia.mp3',
    [CHAR_SOUND_OKEY_DOKEY] = 'mario_okey_dokey.mp3',
    [CHAR_SOUND_ON_FIRE] = 'mario_on_fire.mp3',
    [CHAR_SOUND_OOOF] = 'mario_ooof.mp3',
    [CHAR_SOUND_OOOF2] = 'mario_ooof.mp3',
    [CHAR_SOUND_PANTING] = 'mario_panting.mp3',
    [CHAR_SOUND_PANTING_COLD] = 'mario_panting_cold.mp3',
    [CHAR_SOUND_PUNCH_HOO] = 'mario_punch_hoo.mp3',
    [CHAR_SOUND_PUNCH_WAH] = 'mario_wah.mp3',
    [CHAR_SOUND_PUNCH_YAH] = 'mario_punch_yah.mp3',
    [CHAR_SOUND_SNORING1] = 'mario_snoring_1.mp3',
    [CHAR_SOUND_SNORING2] = 'mario_snoring_2.mp3',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'mario_so_longa_bowser.mp3',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'mario_twirl_bounce.mp3',
    [CHAR_SOUND_UH] = 'mario_grunt.mp3',
    [CHAR_SOUND_UH2] = 'mario_grunt_2.mp3',
    [CHAR_SOUND_UH2_2] = 'mario_grunt_2.mp3',
    [CHAR_SOUND_WAAAOOOW] = 'mario_falling.mp3',
    [CHAR_SOUND_WAH2] = 'mario_wah.mp3',
    [CHAR_SOUND_WHOA] = 'mario_whoa.mp3',
    [CHAR_SOUND_YAHOO] = 'mario_yahoo.mp3',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'mario_yahoo.mp3', 'mario_yippee.mp3'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'mario_punch_yah.mp3', 'mario_yah.mp3'},
}

-- Load Models
local E_MODEL_DEMOMAN = smlua_model_util_get_id("demoman_geo")
local E_MODEL_DEMOMANB = smlua_model_util_get_id("demomanblu_geo")

-- Character Initialize
local CT_DEMOMAN = _G.charSelect.character_add("Demoman", "Drunk.", "LukasATBK, Kazenr", {r = 228, g = 50, b = 50}, E_MODEL_DEMOMAN, CT_MARIO, TEX_DEMOMAN)

-- Add Voices
_G.charSelect.character_add_voice(E_MODEL_DEMOMAN, VOICETABLE_DEMOMAN)
_G.charSelect.character_add_voice(E_MODEL_DEMOMANB, VOICETABLE_DEMOMAN)

-- Update Voicelines
local character_get_voice, update_sound, update_snore = _G.charSelect.character_get_voice, _G.charSelect.voice.sound, _G.charSelect.voice.snore
local function character_sounds(m, sound)
    local v = _G.charSelect.character_get_voice(m)
    if v == VOICETABLE_DEMOMAN
    then
        return update_sound(m, sound)
    end
end
local function character_snore(m)
    local v = _G.charSelect.character_get_voice(m)
    if v == VOICETABLE_DEMOMAN
    then
        return update_snore(m)
    end
end

hook_event(HOOK_CHARACTER_SOUND, character_sounds)
hook_event(HOOK_MARIO_UPDATE, character_snore)

--------------------------------------------
--- Alt Costume code from Paper Partners ---
-- Modified by Squishy for Azumanga Daioh --
--------------------------------------------

local character_edit = _G.charSelect.character_edit
local character_get_current_number = _G.charSelect.character_get_current_number
local character_get_current_table = _G.charSelect.character_get_current_table
local get_options_status = _G.charSelect.get_options_status
local get_menu_color = _G.charSelect.get_menu_color
local hook_render_in_menu = _G.charSelect.hook_render_in_menu

local table_insert = table.insert
local play_sound = play_sound
local djui_hud_get_screen_width = djui_hud_get_screen_width
local djui_hud_measure_text = djui_hud_measure_text
local djui_hud_set_color = djui_hud_set_color
local djui_hud_set_resolution = djui_hud_set_resolution
local djui_hud_set_rotation = djui_hud_set_rotation
local djui_hud_set_font = djui_hud_set_font
local djui_hud_print_text = djui_hud_print_text
local djui_hud_render_rect = djui_hud_render_rect
local maxf = maxf
local math_min = math.min
local math_max = math.max
local math_sin = math.sin

local altCostumes = {
    [CT_DEMOMAN] = {
        currSkin = 1,
        {name = "Team Red", model = E_MODEL_DEMOMAN,},
        {name = "Team Blu", model = E_MODEL_DEMOMANB,},
    },
}

local function update_character_skin(currChar, currAlt)
    local currSkin = altCostumes[currChar][currAlt]
    if altCostumes[currChar].desc == nil then
        altCostumes[currChar].desc = character_get_current_table().description
    end
    local description = {}
    for i = 1, #altCostumes[currChar].desc do
        table_insert(description, altCostumes[currChar].desc[i])
    end
    if currSkin.name ~= "" then
        table_insert(description, "")
        table_insert(description, "Current Outfit: "..currSkin.name)
    end
    character_edit(currChar, nil, description, nil, nil, currSkin.model, nil, nil)
    local cameraToObject = gMarioStates[0].marioObj.header.gfx.cameraToObject
    play_sound(SOUND_MENU_MESSAGE_NEXT_PAGE, cameraToObject)
end

local inputLockTimer = 0
local buttonAnimTimer = 0

local MATH_DIVIDE_320 = 1/320

local latencyValueTable = {12, 6, 3}

local function hud_render()
    local width = djui_hud_get_screen_width() + 1.4
    local widthScale = maxf(width, 321.4) * MATH_DIVIDE_320
    local currChar = character_get_current_number()
    local charColors = character_get_current_table().color
    
    -- Mimick button swaying, which is missing from the paper code
    local buttonAnim = 0
    local charSelectAnim = get_options_status(_G.charSelect.optionTableRef.anims)
    if charSelectAnim > 0 then
        buttonAnimTimer = buttonAnimTimer + 1
        buttonAnim = math_sin(buttonAnimTimer * 0.05) * 2.5 + 5
    else
        buttonAnim = 10
    end

    local inputLockTimerTo = latencyValueTable[get_options_status(_G.charSelect.optionTableRef.inputLatency) + 1]

    if altCostumes[currChar] ~= nil then
        -- Render Mod Variond under CS version
        local menuColor = get_menu_color()
        djui_hud_set_color(menuColor.r, menuColor.g, menuColor.b, 255)
        djui_hud_set_font(FONT_TINY)
        local string = TEXT_MOD_NAME.." ("..TEXT_MOD_VERSION..")"
        djui_hud_print_text(string, width - 5 - djui_hud_measure_text(string)*0.5, 3, 0.5)

        ---@type Controller
        local c = _G.charSelect.controller
        local currAlts = altCostumes[currChar]

        djui_hud_set_font(FONT_NORMAL)
        djui_hud_set_resolution(RESOLUTION_N64)
        local inputLockTimerAnim = 0

        local buttonX = 20 * widthScale + buttonAnim
        local x1 = buttonX - 4
        local x2 = x1 + 73
        local y = 97

        if charSelectAnim > 0 then
            inputLockTimerAnim = inputLockTimer/inputLockTimerTo * 3
            x1 = x1 + math_min(inputLockTimerAnim, 0)
            x2 = x2 + math_max(inputLockTimerAnim, 0)
        end
        -- Left Arrow
        if currAlts.currSkin > 1 then
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_set_rotation(0x2000, 0.5, 0.5)
            djui_hud_render_rect(x1, y, 5, 5)
            djui_hud_set_color(0, 0, 0, 255)
            djui_hud_set_rotation(0x0000, 0.5, 0.5)
            djui_hud_render_rect(x1 + 2.5, y - 2, 6, 8)
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_render_rect(buttonX, y - 3, 1, 10)

            if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                currAlts.currSkin = math_max(currAlts.currSkin - 1, 1)
                update_character_skin(currChar, currAlts.currSkin)
                inputLockTimer = -inputLockTimerTo
            end
        end
        -- Right Arrow
        if currAlts.currSkin < #currAlts then
            -- Changed arrows to mimick the ones seen in the options menu
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_set_rotation(0x2000, 0.5, 0.5)
            djui_hud_render_rect(x2, y, 5, 5)
            djui_hud_set_color(0, 0, 0, 255)
            djui_hud_set_rotation(0x0000, 0.5, 0.5)
            djui_hud_render_rect(x2 - 3.5, y - 2, 6, 8)
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_render_rect(buttonX + 69, y - 3, 1, 10)

            if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                currAlts.currSkin = currAlts.currSkin + 1
                update_character_skin(currChar, currAlts.currSkin)
                inputLockTimer = inputLockTimerTo
            end
        end
        -- use an input lock to prevent cycling too fast
        if inputLockTimer > 0 then
            inputLockTimer = inputLockTimer - 1
        elseif inputLockTimer < 0 then
            inputLockTimer = inputLockTimer + 1
        end
    end
end

hook_render_in_menu(hud_render)
